(* IPN Notification Example

   The program uses the port numer 82 so the IPN handler URL must be set as following:
   http://yourdomanin:82

   Indy version 10.1.5
*)

unit HttpForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPServer, IdHTTPServer,
  StdCtrls, StrUtils, IdContext, IdCustomHTTPServer,
  IdCustomTCPServer, IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdHTTP, IdTCPConnection, IdTCPClient;


type
  TForm1 = class(TForm)
    IdHTTPServer1: TIdHTTPServer;
    Memo1: TMemo;
    http1: TIdHTTP;
    OpenSSL: TIdSSLIOHandlerSocketOpenSSL;
    procedure IdHTTPServer1CommandGet(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses IdHTTPHeaderInfo;

{$R *.dfm}

procedure TForm1.IdHTTPServer1CommandGet(AContext: TIdContext;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
var
  strWrite : TStringList;
  strRead  : String;
begin

  Memo1.Lines.Add('Notification:');
  Memo1.Lines.Add(ARequestInfo.FormParams);

  Memo1.Lines.Add('Answer:');
  strWrite := TStringList.Create;
  try
    strWrite.Add(ARequestInfo.FormParams+'&cmd=_notify-validate');
    Memo1.Lines.Add(ARequestInfo.FormParams+'&cmd=_notify-validate');
    Http1.Request.UserAgent := 'application/x-www-form-urlencoded';
    Http1.ReadTimeout := 0;
    Http1.IOHandler := OpenSSL;
    // If you are in live
    // strRead := Http1.Post('https://www.paypal.com/cgi-bin/webscr', strWrite);
    // If you are in sandbox
    strRead := Http1.Post('https://www.sandbox.paypal.com/cgi-bin/webscr', strWrite);
    Memo1.Lines.Add(strRead);
  except
    on E: Exception do
    begin
      showmessage('Error encountered during POST: ' + E.Message);
    end;
  end;
  strWrite.Free;

end;

end.
